/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.93 by jmc, Wed Sep 5 16:09:31 2007 UTC revision 1.124 by jmc, Wed Apr 22 21:07:00 2009 UTC
# Line 11  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mth)                   run multi threaded (using eedata.mth)"      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
15      echo "  (-mpi)                   compile and run using MPI"      echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18        echo "  (-gsl)                   compile with \"-gsl\" flag"
19      echo "  (-of=|-optfile=)STRING   list of optfiles to use"      echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
21      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"\" no email is sent)"
22        echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"
23        echo "                             (DEF=\"../tools/mpack-1.6\")"
24      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"      echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
25      echo "                             (recognized groups: basic, tutorials)"      echo "                             (recognized groups: basic, tutorials)"
26      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
# Line 27  usage() Line 30  usage()
30      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
31      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
32      echo "  (-adm|-ad)               perform an adjoint run"      echo "  (-adm|-ad)               perform an adjoint run"
33        echo "  (-oad)                   perform an OpenAD adjoint run"
34      echo "  (-command) STRING        command to run"      echo "  (-command) STRING        command to run"
35      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
36      echo "  (-m|-make) STRING        command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
# Line 64  usage() Line 68  usage()
68  build_mpack()  build_mpack()
69  {  {
70      printf "building the mpack utility...  "      printf "building the mpack utility...  "
71      if test ! -x "$MPACKDIR/mpack" ; then      MPACK="$MPACKDIR/mpack"
72        if test ! -x $MPACK ; then
73          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
74              echo              echo
75              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
# Line 73  build_mpack() Line 78  build_mpack()
78              echo              echo
79              HAVE_MPACK=f              HAVE_MPACK=f
80          fi          fi
         printf "building mpack...  "  
81          if test "x$CC" = x ; then          if test "x$CC" = x ; then
82              export CC=cc              export CC=cc
83          fi          fi
84            printf "building mpack (using CC=$CC)...  "
85          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
86          RETVAL=$?          RETVAL=$?
87          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
# Line 87  build_mpack() Line 92  build_mpack()
92          else          else
93              rm -f tr_build_mpack.out              rm -f tr_build_mpack.out
94              HAVE_MPACK=t              HAVE_MPACK=t
95                echo "done"
96          fi          fi
97      else      else
98          HAVE_MPACK=t          HAVE_MPACK=t
99            echo "already exist"
100      fi      fi
     echo "OK"  
101  }  }
102    
103  testoutput_var()  testoutput_var()
104  {  {
105      # testoutput_var dir s1 label subdir extension      # testoutput_var dir s1 label subdir reference_output
106      #      #
107      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
108      #     with same output from reference file $dir/results/output.$extension      #     with same output from reference file $dir/results/$reference_output
109      #  using search strings s1 and text label      #  using search strings s1 and text label
110    
111      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
# Line 108  testoutput_var() Line 114  testoutput_var()
114      if [ -r $1/$4/$OUTPUTFILE ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
115          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
116          lncntA=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
117          if [ $lncntA -lt 3 ]; then          if [ $lncntA -lt 2 ]; then
118              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
119                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
120              fi              fi
# Line 119  testoutput_var() Line 125  testoutput_var()
125          return 99          return 99
126      fi      fi
127      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
128          echo testoutput_var: grep "$2" $1/results/output.$5 1>&2          echo testoutput_var: grep "$2" $1/results/$5 1>&2
129      fi      fi
130      grep "$2" $1/results/output.$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
131      lncntB=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
132      if [ $lncntB -lt 3 ]; then      if [ $lncntB -lt 2 ]; then
133          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
134              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
135          fi          fi
# Line 161  testoutput_var() Line 167  testoutput_var()
167      digits_of_similarity=`./tr_cmpnum < tmp4.txt`      digits_of_similarity=`./tr_cmpnum < tmp4.txt`
168      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
169          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
170              echo testoutput_var: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
171          fi          fi
172          digits_of_similarity=99          digits_of_similarity=99
173      else      else
174          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
175              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
176          fi          fi
177      fi      fi
178      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
# Line 174  testoutput_var() Line 180  testoutput_var()
180      return $digits_of_similarity      return $digits_of_similarity
181  }  }
182    
 dashnum()  
 {  
     # dashnum n1 n2 n3 ...  
     #  
     #  print numbers using %3i format or "--" if number = 99  
   
     for num in $@ ; do  
         if [ $num = 99 ]; then  
             printf ' --'  
         else  
             printf '%3i' $num  
         fi  
     done  
 }  
   
 testoutput_ad()  
 {  
     grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $5}' > t05.txt  
     grep $3 $1/$2/$OUTPUTFILE | awk '{print NR " " $5}' > t15.txt  
     grep $3 $1/results_ad/output_adm.txt | awk '{print NR " " $6}' > t06.txt  
     grep $3 $1/$2/$OUTPUTFILE | awk '{print NR " " $6}' > t16.txt  
     join t05.txt t15.txt > t5.txt  
     join t06.txt t16.txt > t6.txt  
     echo "-1" >> t5.txt  
     echo "-1" >> t6.txt  
     digits_5=`./tr_cmpnum < t5.txt`  
     digits_6=`./tr_cmpnum < t6.txt`  
     dashnum $digits_5 $digits_6  
     rm -f t[01][56].txt t[56].txt  
 }  
   
 check_for_add_mon_output()  
 {  
     # Check for additional types of monitor output  
     if test "x$1" = x ; then  
         return  
     fi  
   
     for ii in $PTRACERS_NUM ; do  
         eval "HAVE_PTR0"$ii"=f"  
     done  
   
     ptr_add="trcstat_ptracerXX_min trcstat_ptracerXX_max"  
     ptr_add="$ptr_add trcstat_ptracerXX_mean trcstat_ptracerXX_sd"  
     for ii in $PTRACERS_NUM ; do  
         for jj in $ptr_add ; do  
             name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`  
             tst=`grep $name $1 | wc -l | awk '{print $1}'`  
             if test ! "x$tst" = x0 ; then  
                 eval "HAVE_PTR0"$ii"=t"  
             fi  
         done  
         #  eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"'  
     done  
 }  
   
183  testoutput_run()  testoutput_run()
184  {  {
185      # testoutput_run directory subdir extension      # testoutput_run directory subdir reference_output
186      #      #
187      #  test output from 1 run in "directory"      #  test output from 1 run in "directory"
188      if test "x$ADM" = x ; then  # --> same processing for adjoint & forward test
189          if [ $debug -gt 0 ]; then          # default list of output variables to be checked:
190              echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2          #  1rst : main variable used to decide if it pass or FAIL
191          fi          #  others : number of matching digits to be printed in summary.txt
192          testoutput_var $1 "cg2d_init_res" "cg2d init. residual" $2 $3; cg2dres=$?          listChk=$DEF_CHECK_LIST
193          if [ $debug -gt 0 ]; then          #  load experiment-specific list from file "tr_checklist" (if it exist)
194              echo testoutput_run: cg2dres=$cg2dres 1>&2          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
195          fi          sVar=`echo $listChk | awk '{print $1}'`
196          testoutput_var $1 "dynstat_theta_min" "theta minimum" $2 $3; tmin=$?          # remove 1rst var and expand the list: + => min max mean s.d
197          testoutput_var $1 "dynstat_theta_max" "theta maximum" $2 $3; tmax=$?          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
198          testoutput_var $1 "dynstat_theta_mean" "theta mean" $2 $3; tmean=$?                                 | sed 's/+//g' | sed "s/^$sVar//"`
199          testoutput_var $1 "dynstat_theta_sd" "theta s.d." $2 $3; tsd=$?          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
200          testoutput_var $1 "dynstat_salt_min" "salt minimum" $2 $3; smin=$?          # check for ptracer output in reference_output file :
201          testoutput_var $1 "dynstat_salt_max" "salt maximum" $2 $3; smax=$?          outpref=$1/results/$3
202          testoutput_var $1 "dynstat_salt_mean" "salt mean" $2 $3; smean=$?          ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
203          testoutput_var $1 "dynstat_salt_sd" "salt s.d." $2 $3; ssd=$?          ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
         testoutput_var $1 "dynstat_uvel_min" "U minimum" $2 $3; umin=$?  
         testoutput_var $1 "dynstat_uvel_max" "U maximum" $2 $3; umax=$?  
         testoutput_var $1 "dynstat_uvel_mean" "U mean" $2 $3; umean=$?  
         testoutput_var $1 "dynstat_uvel_sd" "U s.d." $2 $3; usd=$?  
         testoutput_var $1 "dynstat_vvel_min" "V minimum" $2 $3; vmin=$?  
         testoutput_var $1 "dynstat_vvel_max" "V maximum" $2 $3; vmax=$?  
         testoutput_var $1 "dynstat_vvel_mean" "V mean" $2 $3; vmean=$?  
         testoutput_var $1 "dynstat_vvel_sd" "V s.d." $2 $3; vsd=$?  
   
         #  This is for PTRACERS  
204          for ii in $PTRACERS_NUM ; do          for ii in $PTRACERS_NUM ; do
205              eval `echo "p0"$ii"_min=99"`              ptrfound=0
206              eval `echo "p0"$ii"_max=99"`              for jj in $ptr_mon ; do
207              eval `echo "p0"$ii"_mean=99"`                  name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
208              eval `echo "p0"$ii"_sd=99"`                  tst=`grep $name $outpref | wc -l | awk '{print $1}'`
209              tst=`eval 'echo "$HAVE_PTR0'$ii'"'`                  if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
210              #echo 'tst = '$tst              done
211              if test "x$tst" = xt ; then              if test $ptrfound = '1' ; then
212                  a="trcstat_ptracer0"                  eval "HAVE_PTR0"$ii"=t"
213                  testoutput_var $1 "$a"$ii"_min"  "p0"$ii"_min"  $2 $3              else
214                  RETVAL=$? ; eval `echo "p0"$ii"_min="$RETVAL`                  eval "HAVE_PTR0"$ii"=f"
215                  testoutput_var $1 "$a"$ii"_max"  "p0"$ii"_max"  $2 $3                if test "x$ADM" = x -a "x$OADM" = x; then
216                  RETVAL=$? ; eval `echo "p0"$ii"_max="$RETVAL`                # remove this ptr from the list of output variable to check
217                  testoutput_var $1 "$a"$ii"_mean" "p0"$ii"_mean" $2 $3                # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
218                  RETVAL=$? ; eval `echo "p0"$ii"_mean="$RETVAL`                  listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
219                  testoutput_var $1 "$a"$ii"_sd"   "p0"$ii"_sd"   $2 $3                fi
                 RETVAL=$? ; eval `echo "p0"$ii"_sd="$RETVAL`  
220              fi              fi
221            #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
222          done          done
223            tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
224          allargs="$cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd"          if test $tst != 1 ; then
225          allargs="$allargs $umin $umax $umean $usd $vmin $vmax $vmean $vsd"            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
226          allargs="$allargs $p01_min $p01_max $p01_mean $p01_sd"                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
227          allargs="$allargs $p02_min $p02_max $p02_mean $p02_sd"            echo "==> WARNING: in checked list:" $listVar 1>&2
228          allargs="$allargs $p03_min $p03_max $p03_mean $p03_sd"          #- put it back once:
229          allargs="$allargs $p04_min $p04_max $p04_mean $p04_sd"            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
230          allargs="$allargs $p05_min $p05_max $p05_mean $p05_sd"          fi
231            if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
232          eval "dashnum $allargs"          echo "listVar='$listVar'" > $CDIR"/summary.txt"
233            allargs=""
234      else          for xx in $listVar
235          testoutput_ad $1 $2 "precision_grdchk_result"          do
236      fi            case $xx in
237               'PS')  if [ $debug -gt 0 ]
238                      then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
239                      testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
240                      if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
241              'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
242              'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
243               'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;
244               'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;
245               'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;
246               'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;
247               'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;
248               'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;
249               'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;
250               'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;
251               'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
252               'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
253               'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
254               'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;
255               'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
256               'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
257               'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
258               'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;
259            'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
260               testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
261            'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
262               testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;
263            'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
264               testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
265            'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
266               testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
267             'Qntmn') testoutput_var $1 "extforcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
268             'Qntmx') testoutput_var $1 "extforcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
269             'Qntav') testoutput_var $1 "extforcing_qnet_mean" "Qnet mean"    $2 $3; yy=$? ;;
270             'Qntsd') testoutput_var $1 "extforcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
271             'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
272             'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
273             'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
274             'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
275             'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
276             'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Hell max"   $2 $3; yy=$? ;;
277             'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Hell mean"  $2 $3; yy=$? ;;
278             'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Hell StDv"  $2 $3; yy=$? ;;
279            'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
280            'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
281            'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
282            'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;
283            'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;
284            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;
285                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
286              esac
287              if test $xx = $sVar
288              then allargs="$allargs > $yy <"
289              else allargs="$allargs $yy"
290              fi
291            done
292    
293            nbVar=`echo $listVar | awk '{print NF}'`
294            if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
295            #-- fill line (up to standard length) with dot:
296              adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
297              echo $allargs $adNul
298            else
299              echo $allargs
300            fi
301    # <-- same processing for adjoint & forward test
302  }  }
303    
304  genmakemodel()  genmakemodel()
# Line 310  genmakemodel() Line 315  genmakemodel()
315          (          (
316              cd $1;              cd $1;
317              command="$GENMAKE2  -ds -m $MAKE"              command="$GENMAKE2  -ds -m $MAKE"
318              if test "x$ADM" = x ; then              if test "x$ADM" = xt ; then
                 command="$command --mods=../code"  
             else  
319                  command="$command --mods=../code_ad"                  command="$command --mods=../code_ad"
320                elif test "x$OADM" = xt ; then
321                    command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"
322                else
323                    command="$command -mods=../code"
324              fi              fi
325              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
326                  command="$command --optfile=$OPTFILE"                  command="$command -optfile=$OPTFILE"
327              fi              fi
328              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
329                  command="$command -ieee"                  command="$command -ieee"
330              fi              fi
331                if test "x$GSL" = xt ; then
332                    command="$command -gsl"
333                fi
334              if test "x$MPI" = xt ; then              if test "x$MPI" = xt ; then
335                  command="$command -mpi"                  command="$command -mpi"
336              fi              fi
337                if test "x$MULTI_THREAD" = xt ; then
338                #- run multi-threaded using OpenMP:
339                    command="$command -omp"
340                fi
341              if test "x$TS" = xt ; then              if test "x$TS" = xt ; then
342                  command="$command -ts"                  command="$command -ts"
343              fi              fi
# Line 335  genmakemodel() Line 349  genmakemodel()
349              fi              fi
350              fi              fi
351              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
352              $command > make.log 2>&1              # $command > make.log 2>&1
353                eval $command > make.log 2>&1
354              RETVAL=$?              RETVAL=$?
355              #  Reduce the size of the testing emails!              #  Reduce the size of the testing emails!
356              head -100 Makefile > $CDIR/Makefile_head              head -100 Makefile > $CDIR/Makefile_head
# Line 393  run_clean() Line 408  run_clean()
408              find . -type l -exec rm {} \;              find . -type l -exec rm {} \;
409              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime              rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
410              rm -rf mnc_test_*              rm -rf mnc_test_*
411                rm -f *_MIT_CE_000.opt0000 costfunction*0000
412              echo successful 1>&2              echo successful 1>&2
413              exit 0              exit 0
414          )          )
# Line 429  makemodel() Line 445  makemodel()
445          cd $1;          cd $1;
446          if test -r Makefile ; then          if test -r Makefile ; then
447              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
448              if test "x$ADM" = x ; then              if test "x$ADM" = xt ; then
449                    $MAKE adall >> make.log 2>&1
450                elif test "x$OADM" = xt ; then
451                    $MAKE adAll >> make.log 2>&1
452                else
453                  if test "x$JOBS" = x ; then                  if test "x$JOBS" = x ; then
454                      $MAKE >> make.log 2>&1                      $MAKE >> make.log 2>&1
455                  else                  else
456                      $MAKE -j $JOBS >> make.log 2>&1                      $MAKE -j $JOBS >> make.log 2>&1
457                  fi                  fi
             else  
                 $MAKE adall >> make.log 2>&1  
458              fi              fi
459              RETVAL=$?              RETVAL=$?
460              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
# Line 463  symlink_mpifiles() Line 481  symlink_mpifiles()
481      CODE_DIR=$dir/$code_dir      CODE_DIR=$dir/$code_dir
482            
483      # These are files that should replace their counter-part when using -mpi      # These are files that should replace their counter-part when using -mpi
484      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
485    
486      #  Is this an MPI run?      #  Is this an MPI run?
487      if test "x$MPI" = xt ; then      if test "x$MPI" = xt ; then
# Line 521  linkdata() Line 539  linkdata()
539                      if test -h eedata ; then rm -f eedata ; fi                      if test -h eedata ; then rm -f eedata ; fi
540                  fi                  fi
541              fi              fi
542                prevDir='NONE'
543              for ldir in $* ; do              for ldir in $* ; do
544                  if test -d "../"$ldir ; then                  if test -d "../"$ldir -a $ldir != $prevDir ; then
545                      printf 'ldir='${ldir} 1>&2                      printf 'ldir='${ldir} 1>&2
546                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
547                      for i in $files ; do                      for i in $files ; do
# Line 538  linkdata() Line 557  linkdata()
557                      fi                      fi
558                      printf ' ; ' 1>&2                      printf ' ; ' 1>&2
559                  fi                  fi
560                    prevDir=$ldir
561              done              done
562          )          )
563      fi      fi
# Line 554  runmodel() Line 574  runmodel()
574          printf 'runmodel in %s ...' $1 1>&2          printf 'runmodel in %s ...' $1 1>&2
575          # make output.txt          # make output.txt
576          echo          echo
577            if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
578                diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
579                outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi
580            fi
581          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
582              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_00              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
583              ln -sf "../"$builddir"/"$EXECUTABLE .              ln -sf "../"$builddir"/"$EXECUTABLE .
584          fi          fi
585          if test ! -x $EXECUTABLE ; then          if test ! -x $EXECUTABLE ; then
586                  rm -f run.log ; touch run.log                  rm -f $RUNLOG ; touch $RUNLOG
587                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                  if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
588                  echo " no executable:" $EXECUTABLE >> run.log                  echo " no executable:" $EXECUTABLE >> $RUNLOG
589                  RETVAL=8                  RETVAL=8
590                  ENDVAL=-1                  ENDVAL=-1
591          else          else
592              if test $OUTPUTFILE -ot $EXECUTABLE ; then              if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
593                  rm -f run.log ; touch run.log                # output do not exist or is older than executable:
594                  if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                  rm -f $RUNLOG ; touch $RUNLOG
595                  ( eval $COMMAND ) >> run.log 2>&1                  if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
596                    ( eval $COMMAND ) >> $RUNLOG 2>&1
597                  RETVAL=$?                  RETVAL=$?
598              else              else
599                  RETVAL=0                  RETVAL=0
600                  if test -f run.log ; then                  if test -f $RUNLOG ; then
601                      if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
602                      echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
603                  else                  else
604                      touch run.log                      touch $RUNLOG
605                      if test -f run.log_00 ; then cat run.log_00 >> run.log ; fi                      if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
606                      echo "---------->> $OUTPUTFILE is up to date " >> run.log 2>&1                      echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
607                      echo " no previous run.log: assume NORMAL END" >> run.log 2>&1                      echo " no previous $RUNLOG: assume NORMAL END" >> $RUNLOG 2>&1
608                  fi                  fi
609              fi              fi
610              ENDVAL=`cat run.log | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`              ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
611          fi          fi
612          rm -f run.log_00          rm -f run.log_tmp
613          #if test "x$RETVAL" = x0 ; then          #if test "x$RETVAL" = x0 ; then
614          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
615              tail run.log              tail $RUNLOG
616              echo successful 1>&2              echo successful 1>&2
617              # === Reduce the size of the testing emails!              # === Reduce the size of the testing emails!
618              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
619              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
620              return 0              return 0
621          else          else
622              tail run.log              tail $RUNLOG
623              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
624              cp run.log $CDIR"/run.log"              cp $RUNLOG $CDIR"/"$RUNLOG
625              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
626              return 1              return 1
627          fi          fi
# Line 607  createcodelet() Line 632  createcodelet()
632  {  {
633      # create codelet for comparing model output      # create codelet for comparing model output
634    
635      printf "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
636      cat > tr_cmpnum.c <<EOF      cat > tr_cmpnum.c <<EOF
637  #include <stdio.h>  #include <stdio.h>
638  #include <math.h>  #include <math.h>
# Line 616  int main( int argc, char** argv )  { Line 641  int main( int argc, char** argv )  {
641    double a,b,abave,relerr;    double a,b,abave,relerr;
642    best = -22;    best = -22;
643    lncnt = 0;    lncnt = 0;
644    while( 1 & (lncnt+=1) < 999 )  {    while( 1 & ( (lncnt+=1) < 999 ) )  {
645      scanf("%d", &linnum);      scanf("%d", &linnum);
646      if (linnum == -1)  break;      if (linnum == -1)  break;
647      scanf("%lf", &a);  scanf("%lf", &b);      scanf("%lf", &a);  scanf("%lf", &b);
# Line 660  formatresults() Line 685  formatresults()
685      nm=$1      nm=$1
686      printf '%s %s %s %s' $2 $3 $4 $5      printf '%s %s %s %s' $2 $3 $4 $5
687      shift; shift; shift; shift; shift;      shift; shift; shift; shift; shift;
688      printf '%3s' $@      listPrt=$@
689        listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
690        xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
691        printf '%3s' $listPrt
692    #   line below does not work on hp-ux_ia64 : do those substitutions later on
693    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
694            
695      if [ $1 = '--' ]; then      if [ $xx = '..' ]; then
696            printf ' N/O '
697        elif [ $xx = '--' ]; then
698            printf ' N/O '
699        elif [ $xx = 99 ]; then
700          printf ' N/O '          printf ' N/O '
701      else      else
702          if [ $1 -ge $MATCH_CRIT ]; then          if [ $xx -ge $MATCH_CRIT ]; then
703              printf ' pass'              printf ' pass'
704          else          else
705              printf ' FAIL'              printf ' FAIL'
# Line 680  scandirs() Line 714  scandirs()
714  {  {
715      if [ $# -eq 1 ]; then      if [ $# -eq 1 ]; then
716          for arg in * ; do          for arg in * ; do
717              test -d $arg/$1 && echo $arg              test -f $arg/$1 && echo $arg
718          done          done
719      else      else
720          echo $*          echo $*
# Line 688  scandirs() Line 722  scandirs()
722  }  }
723    
724    
725    check_eedata()
726    {
727        # check_eedata size.h eedata
728        if [ $# -eq 2 ] ; then
729          if test -f $1 -a -f $2 ; then
730          sx=`grep "^     & *nSx *=" $1 | sed "s/^     & *nSx *=//" | sed 's/, *$//'`
731          nx=`grep "^ *nTx *=" $2 | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
732          if test "x$nx" = x ; then
733            rx=10
734          else
735            rx=`expr $sx % $nx`
736          fi
737          sy=`grep "^     & *nSy *=" $1 | sed "s/^     & *nSy *=//" | sed 's/, *$//'`
738          ny=`grep "^ *nTy *=" $2 | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
739          if test "x$ny" = x ; then
740            ry=20
741          else
742            ry=`expr $sy % $ny`
743          fi
744          echo `expr $rx + $ry`
745        else
746          echo '-1'
747          fi
748        else
749          echo '-2'
750        fi
751    
752    }
753    
754  ###############################################################################  ###############################################################################
755    
756    
# Line 695  scandirs() Line 758  scandirs()
758  debug=0  debug=0
759  verbose=1  verbose=1
760  clean=0  clean=0
 expts=''  
 # ieee=1  
761    
762  IEEE=true  IEEE=true
763  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
764      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
765  fi  fi
766    GSL=f
767    
768  CLEANUP=f  CLEANUP=f
769  QUICK=f  QUICK=f
# Line 718  TESTDIRS= Line 779  TESTDIRS=
779  SKIPDIRS=  SKIPDIRS=
780  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
781  HAVE_MPACK=  HAVE_MPACK=
782  MPACK="$MPACKDIR/mpack"  MPACK=
783  COMMAND=  COMMAND=
784  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
785      MAKE=make      MAKE=make
# Line 733  OUTDIR= Line 794  OUTDIR=
794  DELDIR=  DELDIR=
795    
796  ADM=  ADM=
797    OADM=
798    
799  # Additional monitor types  # list of pTracers to check for monitor output
800  PTRACERS_NUM="1 2 3 4 5"  PTRACERS_NUM="1 2 3 4 5"
801    
802  MATCH_CRIT=13  MATCH_CRIT=13
# Line 767  for ac_option ; do Line 829  for ac_option ; do
829              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
830          -addr=* | --addr=*)          -addr=* | --addr=*)
831              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
832            -mpackdir | --mpackdir | -mpd | --mpd)
833                ac_prev=MPACKDIR ;;
834            -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*)
835                MPACKDIR=$ac_optarg ;;
836    
837          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
838              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
# Line 830  for ac_option ; do Line 896  for ac_option ; do
896    
897          -adm | -ad) ADM=t ;;          -adm | -ad) ADM=t ;;
898    
899            -oad) OADM=t; NODEPEND=t ;;
900    
901          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
902          -noieee) IEEE= ;;          -noieee) IEEE= ;;
903            -gsl) GSL=t ;;
904    
905          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
906          -debug) debug=1 ;;          -debug) debug=1 ;;
# Line 865  if test "x$QUICK" = xt ; then Line 934  if test "x$QUICK" = xt ; then
934      NODEPEND=t      NODEPEND=t
935  fi  fi
936    
937    #- setting for forward or ADM testing
938    if test "x$ADM" = xt ; then
939        code_dir=code_ad
940        inputdir=input_ad
941        ref_outp="output_adm.txt"
942        EXECUTABLE="mitgcmuv_ad"
943    elif test "x$OADM" = xt ; then
944        code_dir=code_oad
945        inputdir=input_oad
946        ref_outp="output_oadm.txt"
947        EXECUTABLE="mitgcmuv_ad"
948    else
949        code_dir=code
950        inputdir=input
951        ref_outp="output.txt"
952        EXECUTABLE="mitgcmuv"
953    fi
954    
955  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
956      if test "x$ADM" = xt ; then      LIST=`scandirs results/$ref_outp`
         LIST=`scandirs results_ad`  
     else  
         LIST=`scandirs results`  
     fi  
957  else  else
958      #- expand group of experiments:      #- expand group of experiments:
959      LIST=" "      LIST=" "
# Line 914  if test "x$OPTFILE" = xNONE -a "x$MITGCM Line 997  if test "x$OPTFILE" = xNONE -a "x$MITGCM
997      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
998  fi  fi
999    
1000  if test "x$ADM" = xt ; then  RUNLOG="run.log"
1001      EXECUTABLE="mitgcmuv_ad"  OUTPUTFILE=$ref_outp
     OUTPUTFILE="output_adm.txt"  
 else  
     EXECUTABLE="mitgcmuv"  
     OUTPUTFILE="output.txt"  
 fi  
   
1002  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
1003      COMMAND="./$EXECUTABLE > $OUTPUTFILE"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
1004  fi  fi
# Line 929  if test "x$MPI" = xt ; then Line 1006  if test "x$MPI" = xt ; then
1006      OUTPUTFILE="STDOUT.0000"      OUTPUTFILE="STDOUT.0000"
1007  fi  fi
1008    
 #echo "OK"  
1009  echo "OK (COMMAND= $COMMAND )"  echo "OK (COMMAND= $COMMAND )"
1010    
1011    # set the Default List of output variables to be checked:
1012    #  (use default or load experiment-specific list from file "tr_checklist")
1013    # content : 1rst = main variable used to decide if it pass or FAIL
1014    #         others = number of matching digits to be printed in summary.txt
1015    if test "x$ADM" = x -a "x$OADM" = x; then
1016        DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1017        EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1018        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1019        ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
1020        EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
1021    else
1022        DEF_CHECK_LIST='Grad Cost Grad'
1023        EMPTY_RESULTS='.. ..'
1024        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1025    fi
1026    
1027  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1028  createcodelet  createcodelet
1029    
1030  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1031  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x ; then
1032      echo "skipping mpack build"      echo "skipping mpack build"
1033  else  else
1034      build_mpack      build_mpack
1035  fi  fi
1036    
1037  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1038    CMDLINE=$0
1039    for xx in "$@" ; do nw=`echo $xx | wc -w`
1040        if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"
1041                            else CMDLINE="$CMDLINE '$xx'" ; fi
1042    done
1043    #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1044  MACH=`hostname`  MACH=`hostname`
1045  UNAMEA=`uname -a`  UNAMEA=`uname -a`
1046  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
1047  BASE="tr_"$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
1048  if test "x$OUTDIR" != x ; then  if test "x$OUTDIR" != x ; then
1049      BASE="tr_"$OUTDIR"_"$DATE"_"      BASE="tr_"$OUTDIR"_"$DATE"_"
1050    else
1051        short_name=`hostname | sed 's/\..*$//'`
1052        BASE="tr_"$short_name"_"$DATE"_"
1053  fi  fi
1054  DNUM=0  DNUM=0
1055  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
# Line 963  if test "x$RETVAL" != x0 ; then Line 1064  if test "x$RETVAL" != x0 ; then
1064      exit 1      exit 1
1065  fi  fi
1066  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
 printf "Start time:  " >> $SUMMARY  
1067  start_date=`date`  start_date=`date`
1068  echo $start_date > $SUMMARY  echo $start_date > $SUMMARY
1069    echo 'run:' $CMDLINE >> $SUMMARY
1070    echo 'on :' $UNAMEA  >> $SUMMARY
1071    
1072  of_path=  of_path=
1073  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
# Line 994  else Line 1096  else
1096  fi  fi
1097  echo  echo
1098  echo >> $SUMMARY  echo >> $SUMMARY
1099  if test "x$ADM" = x ; then  if test "x$ADM" = x -a "x$OADM" = x; then
1100      if [ $MATCH_CRIT -lt 10 ] ;      if [ $MATCH_CRIT -lt 10 ] ;
1101      then line_0="      "$MATCH_CRIT ;      then line_0="default  "$MATCH_CRIT ;
1102      else line_0="     "$MATCH_CRIT ; fi      else line_0="default "$MATCH_CRIT ; fi
1103      line_0="   $line_0  ----T-----  ----S-----  ----U-----  ----V-----"         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1104  #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"  #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"
1105      line_1="G D M    c        m  s        m  s        m  s        m  s"      line_1="G D M    c        m  s        m  s        m  s        m  s"
1106      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1107      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1108      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1109      for ii in $PTRACERS_NUM ; do      for ii in $PTRACERS_NUM ; do
         #  tst=`eval 'echo $HAVE_PTR0'$ii`  
         #  if test "x$tst" = xt ; then  
1110          line_0="$line_0  --PTR 0"$ii"--"          line_0="$line_0  --PTR 0"$ii"--"
1111          line_1="$line_1        m  s"          line_1="$line_1        m  s"
1112          line_2="$line_2  m  m  e  ."          line_2="$line_2  m  m  e  ."
1113          line_3="$line_3  i  a  a  d"          line_3="$line_3  i  a  a  d"
1114          line_4="$line_4  n  x  n  ."          line_4="$line_4  n  x  n  ."
         #  fi  
1115      done      done
1116      echo "$line_0" | tee -a $SUMMARY      echo "$line_0" | tee -a $SUMMARY
1117      echo "$line_1" | tee -a $SUMMARY      echo "$line_1" | tee -a $SUMMARY
# Line 1023  if test "x$ADM" = x ; then Line 1122  if test "x$ADM" = x ; then
1122  else  else
1123      echo "ADJOINT=true" >> $SUMMARY      echo "ADJOINT=true" >> $SUMMARY
1124      echo >> $SUMMARY      echo >> $SUMMARY
1125        if [ $MATCH_CRIT -lt 10 ] ;
1126        then line_0="default     "$MATCH_CRIT ;
1127        else line_0="default    "$MATCH_CRIT ; fi
1128        echo "$line_0" | tee -a $SUMMARY
1129      cat << EOF | tee -a $SUMMARY      cat << EOF | tee -a $SUMMARY
1130  G D M    C  G  G D M    C  G
1131  E p a R  o  r  E p a R  o  r
# Line 1035  fi Line 1138  fi
1138  #  ...and each test directory...  #  ...and each test directory...
1139  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
1140            
1141        # set builddir & rundir:
1142        builddir="build"
1143        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1144        rundir="run"
1145        if test ! -d $dir/$rundir ; then
1146            rundir=$builddir
1147        fi
1148        CODE_DIR=$dir/$code_dir
1149        BUILD_DIR=$dir/$builddir
1150    
1151      #  Cleanup only!      #  Cleanup only!
1152      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1153          if test -r $dir/build/Makefile ; then          if test -r $BUILD_DIR/Makefile ; then
1154              echo '  ------  clean dir:' $dir/build              echo '  ------  clean dir:' $dir/$builddir
1155              ( cd $dir/build ; make CLEAN )              ( cd $BUILD_DIR ; make CLEAN )
1156          fi          fi
1157          if test -d $dir/run/CVS ; then          if test -d $dir/$rundir/CVS ; then
1158              echo '  ------  clean dir:' $dir/run              echo '  ------  clean dir:' $dir/$rundir
1159              run_clean $dir/run              run_clean $dir/$rundir
1160          fi          fi
1161          (          (
1162              cd $dir              cd $dir
# Line 1054  for dir in $TESTDIRS ; do Line 1167  for dir in $TESTDIRS ; do
1167    
1168      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1169      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1170      fout=      fout=$dir"/results/"$ref_outp
     if test "x$ADM" = x ; then  
         fout=$dir"/results/output.txt"  
     else  
         fout=$dir"/results_ad/output_adm.txt"  
     fi  
1171      if test ! -r $fout ; then      if test ! -r $fout ; then
1172          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1173          continue          continue
1174      fi      fi
     if test "x$ADM" = x ; then  
         check_for_add_mon_output  $fout  
     fi  
1175    
1176      # Check for additional types of monitor output      # Check for specific files for particular type of run
   
     builddir="build"  
     if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi  
     rundir="run"  
    #rundir=$builddir  
     if test ! -d $dir/$rundir ; then  
         rundir=$builddir  
     fi  
       
     if test "x$ADM" = x ; then  
         code_dir=code  
         CODE_DIR=$dir/code  
         input_dirs='input'  
     else  
         code_dir=code_ad  
         CODE_DIR=$dir/code_ad  
         input_dirs='input_ad input'  
     fi  
     BUILD_DIR=$dir/$builddir  
1177    
1178      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1179          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
# Line 1097  for dir in $TESTDIRS ; do Line 1183  for dir in $TESTDIRS ; do
1183          echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"          echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1184          continue          continue
1185      fi      fi
1186        if test "x$MPI" = "xt" -a "x$MULTI_THREAD" = "xt" ; then
1187          retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/input/eedata.mth"`
1188          if test $retv != 0 ; then
1189            echo "input/eedata.mth tiling misfit -- skipping $dir"
1190            continue
1191          fi
1192        fi
1193    
1194      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1195      extra_runs=      extra_runs=
1196      if test "x$ADM" = x ; then      ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1197          ex_run_dirs=`( cd $dir ; echo input.* )`      #echo "ex_run_dirs='$ex_run_dirs'"
1198          #echo "ex_run_dirs='$ex_run_dirs'"      for exd in $ex_run_dirs ; do
1199          for exd in $ex_run_dirs ; do          name=`echo $exd | sed -e "s/$inputdir\.//"`
1200              name=`echo $exd | sed -e 's/input.//g'`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1201              outf="$dir/results/output.$name.txt"          outf="$dir/results/$refExOut"
1202              if test -f $outf -a -r $outf ; then          if test -f $outf -a -r $outf ; then
1203                  if test "x$MULTI_THREAD" = "xt" ; then            if test "x$MULTI_THREAD" = "xt" ; then
1204                      if test -r $dir"/"$exd"/eedata.mth" ; then              if test -r $dir"/"$exd"/eedata.mth" ; then
1205                          extra_runs="$extra_runs $name"                if test "x$MPI" = "xt" ; then
1206                      #else echo $dir"/"$exd"/eedata.mth: not found"                  retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`
1207                      fi                  if test $retv = 0 ; then
                 else  
1208                      extra_runs="$extra_runs $name"                      extra_runs="$extra_runs $name"
1209                    else
1210                        echo $exd"/eedata.mth tiling misfit -- skipping $dir"
1211                  fi                  fi
1212              fi                else
1213          done                  extra_runs="$extra_runs $name"
1214      fi                fi
1215                #else echo $dir"/"$exd"/eedata.mth: not found"
1216                fi
1217              else
1218                extra_runs="$extra_runs $name"
1219              fi
1220            fi
1221        done
1222    
1223      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1224      echo      echo
# Line 1128  for dir in $TESTDIRS ; do Line 1229  for dir in $TESTDIRS ; do
1229      fi      fi
1230      echo      echo
1231      unset genmake makedepend make run      unset genmake makedepend make run
1232      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'      results=$EMPTY_RESULTS
1233    
1234      #  Create an output dir for each OPTFILE/tdir combination      #  Create an output dir for each OPTFILE/tdir combination
1235      rel_CDIR=$DRESULTS"/"$dir      rel_CDIR=$DRESULTS"/"$dir
# Line 1146  for dir in $TESTDIRS ; do Line 1247  for dir in $TESTDIRS ; do
1247              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1248              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1249              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1250              && linkdata $dir/$rundir $input_dirs \              && linkdata $dir/$rundir $inputdir input \
1251              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1252              && results=`testoutput_run $dir $rundir "txt"`              && results=`testoutput_run $dir $rundir $ref_outp`
1253      fi      fi
1254            
1255      echo      echo
     if test "x$ADM" = x ; then  
1256          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1257          echo          echo
1258          echo "$fres" >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1259          echo "fresults='$fres'" > $CDIR"/summary.txt"          touch $CDIR"/summary.txt"
1260            echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1261          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1262          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1263          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1264          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1265            if test "x$ADM" = xt ; then
1266                head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1267                grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1268                                    >> $CDIR"/summary.txt"
1269            fi
1270    
1271          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1272              unset run              unset run
1273              results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'              results=$EMPTY_RESULTS
1274                #  reference output file
1275                refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1276              #  Create an output dir for each OPTFILE/tdir.ex combination              #  Create an output dir for each OPTFILE/tdir.ex combination
1277              rel_CDIR=$DRESULTS"/"$dir"."$ex              rel_CDIR=$DRESULTS"/"$dir"."$ex
1278              mkdir $rel_CDIR              mkdir $rel_CDIR
1279              CDIR=`pwd`"/$rel_CDIR"              CDIR=`pwd`"/$rel_CDIR"
1280              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1281              run_clean $dir/tr_run.$ex              run_clean $dir/tr_run.$ex
1282              linkdata $dir/tr_run.$ex input.$ex input              linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
1283              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1284                  && results=`testoutput_run $dir tr_run.$ex ${ex}".txt"`              && results=`testoutput_run $dir tr_run.$ex $refExOut`
             fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
1285              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1286              fres="$fres.$ex"              fres="$fres.$ex"
1287              echo              echo
1288              echo "$fres" >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1289              echo "fresults='$fres'" > $CDIR"/summary.txt"              touch $CDIR"/summary.txt"
1290                echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1291              echo "MACH='$MACH'" >> $CDIR"/summary.txt"              echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1292              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1293              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1294              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1295                if test "x$ADM" = xt ; then
1296                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1297                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1298                                       >> $CDIR"/summary.txt"
1299                fi
1300              if test "x$POSTCLEAN" = xt ; then              if test "x$POSTCLEAN" = xt ; then
1301                  run_clean $dir/tr_run.$ex                  run_clean $dir/tr_run.$ex
1302              fi              fi
1303          done          done
     else  
         fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
         fres=$fres"$results   $dir"  
         echo  
         echo "$fres" >> $SUMMARY  
         echo "fresults='$fres'" > $CDIR"/summary.txt"  
         echo "MACH='$MACH'" >> $CDIR"/summary.txt"  
         echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"  
         echo "DATE='$DATE'" >> $CDIR"/summary.txt"  
         echo "tdir='$dir'" >> $CDIR"/summary.txt"  
         grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \  
                            >> $CDIR"/summary.txt"  
     fi  
1304    
1305      #postclean $dir/$builddir      #postclean $dir/$builddir
1306      if test "x$POSTCLEAN" = xt ; then      if test "x$POSTCLEAN" = xt ; then
# Line 1213  for dir in $TESTDIRS ; do Line 1313  for dir in $TESTDIRS ; do
1313  done  done
1314    
1315  printf "Start time:  " >> $SUMMARY  printf "Start time:  " >> $SUMMARY
1316  echo $start_date >> $SUMMARY  echo "$start_date" >> $SUMMARY
1317  printf "End time:    " >> $SUMMARY  printf "End time:    " >> $SUMMARY
1318  date >> $SUMMARY  date >> $SUMMARY
1319    
# Line 1247  fi Line 1347  fi
1347  rm -f tr_cmpnum.c tr_cmpnum  rm -f tr_cmpnum.c tr_cmpnum
1348    
1349  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1350      cat $SUMMARY | sed 's/ -- -- -- --//g'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
1351      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1352          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1353      fi      fi
1354      cat $SUMMARY | sed 's/ -- -- -- --//g' > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1355  fi  fi
1356    
1357  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then

Legend:
Removed from v.1.93  
changed lines
  Added in v.1.124

  ViewVC Help
Powered by ViewVC 1.1.22